
/*
 RandomTrade-4
:
1.            .
2.   SL  TP  .    (.3  4):
3.   SL     .
4.   TP     .
5.             OpRandPeriod .
6.          ClRandPeriod .
   .
*/

extern int Balk=1; //   
extern int SL=50; //  -
extern int TP=50; //  -
extern int OpRandPeriod=30; //         
extern int ClRandPeriod=300; //        
extern bool Take_NotStop=true; //  true   ,  false   

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   MathSrand( GetTickCount());
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   MathSrand( GetTickCount());   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//|   ,                      |
//+------------------------------------------------------------------+
int GetOrder()
  {
   int ticket;
   double StopLoss, TakeProfit;
   double Random=MathRand()/32768.0; //     [0;1)
   if (Random<0.5)
         {
         // 
         if (Take_NotStop) {TakeProfit=NormalizeDouble(Bid+TP*Point,Digits); StopLoss=0;}
         else {StopLoss=NormalizeDouble(Bid-SL*Point,Digits); TakeProfit=0;}
         ticket=OrderSend(Symbol(),OP_BUY,0.1,Ask,3,StopLoss,TakeProfit,"",OP_BUY,0,Blue);
         }
   else
         {
         // 
         if (Take_NotStop) {TakeProfit=NormalizeDouble(Ask-TP*Point,Digits); StopLoss=0;}
         else {StopLoss=NormalizeDouble(Ask+SL*Point,Digits); TakeProfit=0;}
         ticket=OrderSend(Symbol(),OP_SELL,0.1,Bid,3,StopLoss,TakeProfit,"",OP_SELL,0,Red);
         }
   return(ticket);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
  if(Volume[0]>1) return(0); 
  int ticket, RandCl;
  int RandOp=MathRand()*OpRandPeriod/32768; //     [0;OpRandPeriod)

  for(int i=0;i<OrdersTotal();i++)
     {
      RandCl=MathRand()*ClRandPeriod/32768; //     [0;ClRandPeriod)
      if (!OrderSelect(i,SELECT_BY_POS,MODE_TRADES)) {Print("O    #",GetLastError()); continue;}
      if (OrderSymbol()!=Symbol()) continue;
      if (RandCl !=0) continue;
      if (OrderType()==0) OrderClose(OrderTicket(),0.1,Bid,3,Blue);
      if (OrderType()==1) OrderClose(OrderTicket(),0.1,Ask,3,Red);
     }
  
   if (RandOp==0) ticket=GetOrder();

   return(0);
  }
//+------------------------------------------------------------------+



